;;;Increments text

(defun C:IT ( /
remERRORTRAP IncTextERRORTRAP remERRORTRAP IncTextERRORTRAP CHARLIST remEX remEXTYPE remEXVALUE remDYNMODE
             NUMCHAR LASTCHAR LASTNUM 2ndLASTCHAR 2ndLASTNUM 3rdLASTCHAR 3rdLASTNUM LEFTLEN remLOOP remTEXT LEFTCHAR remSELECT remTEXTLOOP )
        
(vl-load-com)
  
;;;------------------------------------ERROR TRAP SETTINGS
  
  (setq remERRORTRAP *error*);;;STORE ERROR
  (setq *error* IncTextERRORTRAP);;;RE-ASSIGN ERROR
  
  ;;;----------------------------------DEFINE ERROR TRAP
  
      (defun IncTextERRORTRAP (errorMessage)
        (setq *error* remERRORTRAP)
        ;;;----------------------------RESTORE SETTINGS AT ERROR
        (setvar "SNAPMODE" remSNAPMODE )
        (setvar "DYNMODE" remDYNMODE )
        ;;;----------------------------TEST MESSAGE
        ;;;(alert "IT'S CRASHED!!!!!")
        (princ)
      )
        
  ;;;----------------------------------END DEFINE ERROR TRAP
  
  (setq *error* IncTextERRORTRAP);;;RE-ASSIGN ERROR

;;;------------------------------------INITAL SETTINGS
        
(setq remSNAPMODE (getvar "SNAPMODE"))
(setq remDYNMODE (getvar "DYNMODE"))
        
;;;------------------------------------CHANGE VARIABLES
        
(setvar "SNAPMODE" 0 )
(setvar "DYNMODE" 3 )
        
;;;------------------------------------SET SYMBOLS

(setq CHARLIST (list
                 "" "0" "1" "2" "3" "4" "5" "6" "7" "8" "9" ""
               "" "A" "B" "C" "D" "E" "F" "G" "H" "I" "J" "K" "L" "M" "N" "O" "P" "Q" "R" "S" "T" "U" "V" "W" "X" "Y" "Z" ""
                 "" "a" "b" "c" "d" "e" "f" "g" "h" "i" "j" "k" "l" "m" "n" "o" "p" "q" "r" "s" "t" "u" "v" "w" "x" "y" "z" ""
               ))
        
;;;------------------------------------USER INPUT
        
(if (= remINITVALUE nil) (setq remINITVALUE ""))
(if (= (ssget "_I") nil)
(setq remVALUE (getstring t (strcat "\nStart value: " "<" remINITVALUE ">" )))
(IncPreSel)
)
(if (= remVALUE "") (setq remVALUE remINITVALUE) (setq remINITVALUE remVALUE))
;;;((alert (strcat remVALUE "\n" remINITVALUE)))
  
;;;------------------------------------CHANGE BLOCK ATTRIBUTE
  

(if (= (strcase remVALUE) "ATT") (setq remATT (getstring "Block Attribute?: ")))
(if (= remATT nil) (setq remATT "item"))

  
;;;------------------------------------END CHANGE BLOCK ATTRIBUTE
  
;;;------------------------------------COPY EXISTING TEXT
  
(setq remEX nil)
(if (= (strcase remVALUE) "CC") (setq remEX (car (entsel "Select existing text: "))))
(if (/= remEX nil) (setq remEXTYPE (getpropertyvalue remEX "LocalizedName")))
(if (/= remEX nil) (setq remEXVALUE (cond
    ((= remEXTYPE "Block Reference") (getpropertyvalue remEX remATT))
    ((= remEXTYPE "Text") (getpropertyvalue remEX "textstring"))
    ((= remEXTYPE "MText") (getpropertyvalue remEX "contents"))
    ((= remEXTYPE "Multileader") (getpropertyvalue remEX "MText/Contents"))
                                  )))
(if (/= remEX nil) (progn (setq remVALUE remEXVALUE) (setq remINITVALUE remEXVALUE)))

  
;;;------------------------------------END COPY EXISTING TEXT

  
;;;------------------------------------ANALYSE INPUT

(setq NUMCHAR (strlen remVALUE))
(setq LASTCHAR (substr remVALUE NUMCHAR))
(setq LASTNUM (vl-position LASTCHAR CHARLIST))
  
(if (> NUMCHAR 1) (setq 2ndLASTCHAR (substr remVALUE (- NUMCHAR 1) 1)) (setq 2ndLASTCHAR ""))
(if (= 2ndLASTCHAR "") (setq 2ndLASTNUM (cond ((< LASTNUM 12) 0) ((< LASTNUM 41) 12) ((< LASTNUM 68) 40))))
(if (/= 2ndLASTCHAR "") (setq 2ndLASTNUM (vl-position 2ndLASTCHAR CHARLIST)))
(if (= 2ndLASTNUM nil) (setq 2ndLASTNUM 9999))
  
(if (> NUMCHAR 2) (setq 3rdLASTCHAR (substr remVALUE (- NUMCHAR 2) 1)) (setq 3rdLASTCHAR ""))
(if (= 3rdLASTCHAR "") (setq 3rdLASTNUM (cond ((< 2ndLASTNUM 12) 0) ((< 2ndLASTNUM 41) 12) ((< 2ndLASTNUM 68) 40))))
(if (/= 3rdLASTCHAR "") (setq 3rdLASTNUM (vl-position 3rdLASTCHAR CHARLIST)))
(if (= 3rdLASTNUM nil) (setq 3rdLASTNUM 9999))

(setq LEFTLEN (- NUMCHAR 3))

  
;;;------------------------------------LOOP
  
  (setq remLOOP 1)
  (while (/= remLOOP nil)
;;;------------------------------------SELECT TEXT LOOP 
    
(setq remTEXTLOOP nil)
(while (= remTEXTLOOP nil)
    


;;;(setq remSELECT (ssget "_+.:E:S" '((-4 . "<OR")(0 . "MText")(0 . "Text")(0 . "Multileader")(0 . "Insert")(-4 . "OR>"))))
(if (= remIncPreSel nil) (setq remSELECT (ssget "_+.:E:S")))
(setq remIncPreSel nil)
(setq remTEXT (ssget "P" '((0 . "MText"))))
(if (= remTEXT nil) (setq remTEXT (ssget "P" '((0 . "Text")))))
(if (= remTEXT nil) (setq remTEXT (ssget "P" '((0 . "Multileader")))))
(if (= remTEXT nil) (setq remTEXT (ssget "P" '((0 . "Insert")))))
    
(if (and (= remTEXT nil) (/= (sslength remSELECT) nil)) (setq remTEXTLOOP nil) (setq remTEXTLOOP 1))
(if (= remSELECT nil)(exit))
    
)

;;;------------------------------------END SELECT TEXT LOOP
    
(setq remTEXT (ssname remTEXT 0))
  
(setq remTYPE (getpropertyvalue remTEXT "LocalizedName"))
(cond
  ((= remTYPE "Block Reference") (setpropertyvalue remTEXT remATT remVALUE))
  ((= remTYPE "Text") (setpropertyvalue remTEXT "textstring" remVALUE))
  ((= remTYPE "MText") (setpropertyvalue remTEXT "contents" remVALUE))
  ((= remTYPE "Multileader") (setpropertyvalue remTEXT "MText/Contents" remVALUE))
)

(setq 3rdLASTNUM (cond ((and (= LASTNUM 10) (= 2ndLASTNUM 10) (= 3rdLASTCHAR "")) (+ 3rdLASTNUM 2)) ((and (= LASTNUM 10) (= 2ndLASTNUM 10)) (+ 3rdLASTNUM 1)) ((and (= LASTNUM 38) (= 2ndLASTNUM 38)) (+ 3rdLASTNUM 1)) ((and (= LASTNUM 66) (= 2ndLASTNUM 66)) (+ 3rdLASTNUM 1)) (t 3rdLASTNUM)))
(if (> 3rdLASTNUM 9999) (setq LEFTLEN (+ LEFTLEN 1)));;;;------------<<<<<<<<<<<<<<<<<
(if (> 3rdLASTNUM 9999) (setq 3rdLASTNUM (cond ((= 2ndLASTNUM 10) 2) ((= 2ndLASTNUM 38) 13) ((= 2ndLASTNUM 66) 41) (t (+ 2ndLASTNUM 1)))))
(if (< 3rdLASTNUM 67) (setq 3rdLASTCHAR (nth 3rdLASTNUM CHARLIST)))                                (print "3.3")
  
(setq 2ndLASTNUM (cond ((and (= LASTNUM 10) (= 2ndLASTCHAR "")) (+ 2ndLASTNUM 2)) ((= LASTNUM 10) (+ 2ndLASTNUM 1)) ((= LASTNUM 38) (+ 2ndLASTNUM 1)) ((= LASTNUM 66) (+ 2ndLASTNUM 1)) (t 2ndLASTNUM)))
(setq 2ndLASTNUM (cond ((= 2ndLASTNUM 11) 1) ((= 2ndLASTNUM 39) 13) ((= 2ndLASTNUM 67) 41) (t (+ 2ndLASTNUM 0))))
(if (> 2ndLASTNUM 9999) (setq 3rdLASTCHAR 2ndLASTCHAR 3rdLASTNUM 9999 LEFTLEN (+ LEFTLEN 1)));;;;------------<<<<<<<<<<<<<<<<<
(if (> 2ndLASTNUM 9999) (setq 2ndLASTNUM (cond ((= LASTNUM 10) 2) ((= LASTNUM 38) 13) ((= LASTNUM 66) 41) (t (+ LASTNUM 1)))))
(if (< 2ndLASTNUM 67) (setq 2ndLASTCHAR (nth 2ndLASTNUM CHARLIST)))
    
(setq LASTNUM (cond ((= LASTNUM 10) 1) ((= LASTNUM 38) 13) ((= LASTNUM 66) 41) (t (+ LASTNUM 1))))
(setq LASTCHAR (nth LASTNUM CHARLIST))
    
(if (> LEFTLEN -1) (setq LEFTCHAR (substr remINITVALUE 1 LEFTLEN)) (setq LEFTCHAR ""));;;;------------<<<<<<<<<<<<<<<<<
    
    
(setq remVALUE (strcat LEFTCHAR 3rdLASTCHAR 2ndLASTCHAR LASTCHAR))
    
    (setq remLOOP remVALUE)
    
    
    (setq remINITVALUE remVALUE)
    
    
  );;;END LOOP
  
  
;;;------------------------------------RESTORE SETTINGS
        
(setvar "SNAPMODE" remSNAPMODE )
(setvar "DYNMODE" remDYNMODE )
  
;;;------------------------------------END DEFUN
      )


;;;------------------------------------INCREMENT PRESELECTED TEXT
        

(defun IncPreSel ( / )
  
(setq remEX nil)
(setq FLOORLIST (list
"BASEMENT" "LOWER GROUND FLOOR" "GROUND FLOOR" "MEZZANINE" "1st FLOOR" "2nd FLOOR" "3rd FLOOR" "4th FLOOR" "5th FLOOR" "6th FLOOR" "7th FLOOR" "8th FLOOR" "9th FLOOR"
                  "10th FLOOR" "11th FLOOR" "12th FLOOR" "13th FLOOR" "14th FLOOR" "15th FLOOR" "16th FLOOR" "17th FLOOR" "18th FLOOR" "19th FLOOR"
                  "20th FLOOR" "21st FLOOR" "22nd FLOOR" "23rd FLOOR" "24th FLOOR" "25th FLOOR" "26th FLOOR" "27th FLOOR" "28th FLOOR" "29th FLOOR"
                  "30th FLOOR" "31st FLOOR" "32nd FLOOR" "33rd FLOOR" "34th FLOOR" "35th FLOOR" "36th FLOOR" "37th FLOOR" "38th FLOOR" "39th FLOOR"
                  "40th FLOOR" "41st FLOOR" "42nd FLOOR" "43rd FLOOR" "44th FLOOR" "45th FLOOR" "46th FLOOR" "47th FLOOR" "48th FLOOR" "49th FLOOR"
"Basement" "Lower Ground Floor" "Ground Floor" "Mezzanine" "1st Floor" "2nd Floor" "3rd Floor" "4th Floor" "5th Floor" "6th Floor" "7th Floor" "8th Floor" "9th Floor"
                  "10th Floor" "11th Floor" "12th Floor" "13th Floor" "14th Floor" "15th Floor" "16th Floor" "17th Floor" "18th Floor" "19th Floor"
                  "20th Floor" "21st Floor" "22nd Floor" "23rd Floor" "24th Floor" "25th Floor" "26th Floor" "27th Floor" "28th Floor" "29th Floor"
                  "30th Floor" "31st Floor" "32nd Floor" "33rd Floor" "34th Floor" "35th Floor" "36th Floor" "37th Floor" "38th Floor" "39th Floor"
                  "40th Floor" "41st Floor" "42nd Floor" "43rd Floor" "44th Floor" "45th Floor" "46th Floor" "47th Floor" "48th Floor" "49th Floor"
"1st" "2nd" "3rd" "4th" "5th" "6th" "7th" "8th" "9th" "10th" "11th" "12th" "13th" "14th" "15th" "16th" "17th" "18th" "19th" "20th" "21st" "22nd" "23rd" "24th" "25th" "26th" "27th" "28th" "29th" "30th" "31st" "32nd" "33rd" "34th" "35th" "36th" "37th" "38th" "39th"
                  "40th" "41st" "42nd" "43rd" "44th" "45th" "46th" "47th" "48th"
"NORTH" "EAST" "SOUTH" "WEST" "NORTH" "EAST" "SOUTH" "WEST" "NORTH ELEVATION" "EAST ELEVATION" "SOUTH ELEVATION" "WEST ELEVATION" "NORTH ELEVATION" "EAST ELEVATION" "SOUTH ELEVATION" "WEST ELEVATION"

                ))
(setq remEX (ssname (ssget "_I") 0))
(setq remEXTYPE (getpropertyvalue remEX "LocalizedName"))
(setq remEXVALUE (cond
    ((= remEXTYPE "Block Reference") (getpropertyvalue remEX remATT))
    ((= remEXTYPE "Text") (getpropertyvalue remEX "textstring"))
    ((= remEXTYPE "MText") (getpropertyvalue remEX "contents"))
    ((= remEXTYPE "Multileader") (getpropertyvalue remEX "MText/Contents"))
                                  ))
(setq remVALUE remEXVALUE remINITVALUE remEXVALUE)
(setq remSELECT (ssget "_I"))
(setq remIncPreSel 1)
(if (or (= remVALUE ".")(= remVALUE "_")(= remVALUE ".")(= remVALUE "")) (setq remVALUE "0"))
(if (/= (vl-position remVALUE FLOORLIST) nil) (IncFloor))
;;;(if (> (strlen remVALUE) 4) (if (or (= (strcase remVALUE) "BASEMENT")(= (strcase remVALUE) "MEZZANINE")(= (strcase (substr remVALUE (- (strlen remVALUE) 4))) "FLOOR")) (IncFloor)))

)

;;;------------------------------------INCREMENT FLOOR LEVELS
        

(defun IncFloor ( / )
(print "IncFloor")

;;;(setq FLOORLISTLEN (length FLOORLIST))
;;;(setq FLOORNUM (atoi (substr remVALUE 1 (- (strlen remVALUE) 8))))
;;;(if (> FLOORNUM 3)
;;;(setq remNUM (+ FLOORNUM 2))
  (setq remNUM (vl-position remVALUE FLOORLIST))
;;;)
  
;;;---------------------------
  
(setq remSELECT (ssget "_I"))
(setq remTEXT (ssget "P" '((0 . "MText"))))
(if (= remTEXT nil) (setq remTEXT (ssget "P" '((0 . "Text")))))
(if (= remTEXT nil) (setq remTEXT (ssget "P" '((0 . "Multileader")))))
(if (= remTEXT nil) (setq remTEXT (ssget "P" '((0 . "Insert")))))
(setq  remTEXT (ssname remTEXT 0))
    
(if (and (= remTEXT nil) (/= (sslength remSELECT) nil)) (setq remTEXTLOOP nil) (setq remTEXTLOOP 1))
(if (= remSELECT nil)(exit))

;;;(if (> (strlen remVALUE) 8) (setq FLOORNUMTH (atoi (substr remVALUE (- (strlen remVALUE) 8) 1))))
;;;(if (> remnum 20) (setq remNUMSUFF (cond ((= FLOORNUMTH 0) "st") ((= FLOORNUMTH 1) "nd") ((= FLOORNUMTH 2) "rd"))))
;;;(if (= remNUMSUFF nil) (setq remNUMSUFF "th"))
  
;;;(if (> remNUM 6)
;;;(setq remVALUE (strcat (rtos (- remNUM 2) 5) remNUMSUFF " FLOOR"))
  (setq remVALUE (nth remNUM FLOORLIST))
;;;)

(setq  remNUM (+ remNUM 1))
(setq remTYPE (getpropertyvalue remTEXT "LocalizedName"))
(cond
  ((= remTYPE "Block Reference") (setpropertyvalue remTEXT remATT remVALUE))
  ((= remTYPE "Text") (setpropertyvalue remTEXT "textstring" remVALUE))
  ((= remTYPE "MText") (setpropertyvalue remTEXT "contents" remVALUE))
  ((= remTYPE "Multileader") (setpropertyvalue remTEXT "MText/Contents" remVALUE))
)

;;;---------------------------
  
(setq remLOOP 1)
(while (/= remLOOP nil)
(setq remTEXTLOOP nil)
(while (= remTEXTLOOP nil)
    
(setq remSELECT (ssget "_+.:E:S"))
(setq remTEXT (ssget "P" '((0 . "MText"))))
(if (= remTEXT nil) (setq remTEXT (ssget "P" '((0 . "Text")))))
(if (= remTEXT nil) (setq remTEXT (ssget "P" '((0 . "Multileader")))))
(if (= remTEXT nil) (setq remTEXT (ssget "P" '((0 . "Insert")))))
(setq  remTEXT (ssname remTEXT 0))
    
(if (and (= remTEXT nil) (/= (sslength remSELECT) nil)) (setq remTEXTLOOP nil) (setq remTEXTLOOP 1))
(if (= remSELECT nil)(exit))
    
)
;;;(if (> (strlen remVALUE) 8) (setq FLOORNUMTH (atoi (substr remVALUE (- (strlen remVALUE) 8) 1))))
;;;(if (> remnum 20) (setq remNUMSUFF (cond ((= FLOORNUMTH 0) "st") ((= FLOORNUMTH 1) "nd") ((= FLOORNUMTH 2) "rd"))))
;;;(if (= remNUMSUFF nil) (setq remNUMSUFF "th"))
  
;;;(if (> remNUM 6)
;;;(setq remVALUE (strcat (rtos (- remNUM 2) 5) remNUMSUFF " FLOOR"))
  (setq remVALUE (nth remNUM FLOORLIST))
;;;)

(setq  remNUM (+ remNUM 1))
(setq remTYPE (getpropertyvalue remTEXT "LocalizedName"))
(cond
  ((= remTYPE "Block Reference") (setpropertyvalue remTEXT remATT remVALUE))
  ((= remTYPE "Text") (setpropertyvalue remTEXT "textstring" remVALUE))
  ((= remTYPE "MText") (setpropertyvalue remTEXT "contents" remVALUE))
  ((= remTYPE "Multileader") (setpropertyvalue remTEXT "MText/Contents" remVALUE))
)
(setq remLOOP remVALUE)

)

(exit)
    
)

;;;(setq remVALUE (strcat (rtos (+ FLOORNUM remNUM) 5) "th FLOOR"))
;;;(setq remVALUE (nth (+ (vl-position remVALUE FLOORLIST) remNUM) FLOORLIST))